#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, cgi, ConfigParser,time, glob, string

form = cgi.FieldStorage()
#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

conf = ConfigParser.RawConfigParser()
conf.read('/config/modbus2mbus.ini')
dconf = ConfigParser.RawConfigParser()
dconf.read('/config/modbus2mbus_default.ini')


def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
        if retval=='':
            retval=dconf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

baudRateList=['300','600','1200','2400','4800','9600','19200','38400']
bitList=['5','6','7','8']
parityList=[('N','No parity'),('O','Odd Parity'),('E','Even Parity'),('M','Mark Parity'),('S','Space Parity')]
stopBitList=['1','2']
ipLocalList=['ALL','ETHERNET1','ETHERNET2']

typeDict={'UDP':'UDP','TCP':'TCP','SER':'Serial'}
portDict={'ALL':'ALL','ETHERNET1':'ETHERNET1','ETHERNET2':'ETHERNET2','RS485':'RS-485','RS232':'RS-232','MBSLAVE':'M-Bus Slave'}
mPortDict={'UDP':{'ALL':[('MBUS','M-Bus')]},'TCP':{'ALL':[('MBUS','M-Bus')]},'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]}}
sPortDict={'UDP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'TCP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'MBSLAVE':[('MBUS','M-Bus')]}}
mProtocolDict={'MBUS':'M-Bus'}
yesno=['YES','NO']

xmlfArray=glob.glob("/config/*.[xX][mM][lL]")
for i in range(len(xmlfArray)):
    xmlfArray[i] = xmlfArray[i][8:] #Error when doing strip("/config/")

m2mversion=""
try:
    mbv=os.popen("/binary/modbus2mbus -v")
    m2mversion=mbv.read()
    mbv.close()
except:
    pass


filename    = getopt('Main','filename')
enable_leds = getopt('Main','enable_leds')

Mtimeout     = getopt('ModbusPort','timeout')
Mporttype    = getopt('ModbusPort','porttype')
Mlocalip     = getopt('ModbusPort','localip')
Mlocalport   = getopt('ModbusPort','localport')
Mremoteip    = getopt('ModbusPort','remoteip')
Mremoteport  = getopt('ModbusPort','remoteport')
Msercomport  = getopt('ModbusPort','sercomport')
Mserbaudrate = getopt('ModbusPort','serbaudrate')
Mserbits     = getopt('ModbusPort','serbits')
#Mserparity   = getopt('ModbusPort','serparity')
Mserstopbit  = getopt('ModbusPort','serstopbit')

Stimeout     = getopt('MBusPort','timeout')
Sporttype    = getopt('MBusPort','porttype')
Slocalip     = getopt('MBusPort','localip')
Slocalport   = getopt('MBusPort','localport')
Sremoteip    = getopt('MBusPort','remoteip')
Sremoteport  = getopt('MBusPort','remoteport')
Ssercomport  = getopt('MBusPort','sercomport')
Sserbaudrate = getopt('MBusPort','serbaudrate')
Sserbits     = getopt('MBusPort','serbits')
Sserparity   = getopt('MBusPort','serparity')
Sserstopbit  = getopt('MBusPort','serstopbit')


import tenjin
from tenjin.helpers import *
engine = tenjin.Engine()
print engine.render('templates/modbus2mbus.pyhtml')

